##########################################################################################
# Developer : Binny V A                                                                  #
# Website   : http://www.geocities.com/binnyva                                           #
# E-Mail    : binnyva@rediffmail.com                                                     #
# Get more Tcl/Tk scripts from http://www.geocities.com/binnyva/code/tcl                 #
##########################################################################################
# Program Name : Perl2Tcl                                                                #
# Version      : 1.00.A                                                                  #
# Started Date : August 29, 2004 - September 08, 2004                                    #
# Description  :                                                                         #
# Converts a perl script to a Tcl Script. Just regular expressions, not a comprehensive  #
#	conversion.                                                                          #
##########################################################################################

proc Perl2Tcl_Config { } {
	defaulter
	set c ".config.one"
	$c.ent_1 configure -state normal
	$c.ent_1 delete 0 end
	$c.ent_1 insert end "tk_messageBox -message " ;#puts
	$c.lab_1 configure -state normal -text "Replace 'print' with"
	.config.but_apply configure -state normal -command "Perl2Tcl"
}

proc Perl2Tcl { } {
	set file_path [getFile]	
	if { $file_path != "" } {
		set in [open "$file_path" r]
		set txt [read $in]
		set flag 1
		set print [.config.one.ent_1 get]
		defaulter
		close $in
		.contents delete 1.0 end
	} else {
		tk_messageBox -message "Please specify a valid file."
		set flag 0
	}
	
	#If no error
	if { $flag } {
		set data ""
		set lines [split $txt "\n"]

		for { set i 0 } { [llength $lines] > $i } { incr i } {
			set no_write 0
			set line [lindex $lines $i]

#Control Flow
			#Else If - All conditions fulfilled except if there is comment at the end of line
			if { [regexp "( *)elsif ?\[\(\] ?(\[^\{\]*) ?\[\)\](.*)" $line full_line zero one two] } {
				set line "$zero\elseif \{ $one \} $two"
				if { ![regexp "\{" $two] } {
					incr i
					set need_line [lindex $lines $i]
					append line "[startBracket $need_line]"
				}
			
			#If - 
			} elseif { [regexp {( *)if ?\( ?([^\{]+) ?\) ?(.*)} $line full_line zero one two] } {
				set line "$zero\if \{ $one \} $two"
				if { ![regexp "\{" $two] } {
					incr i
					set need_line [lindex $lines $i]
					append line "[startBracket $need_line]"
				}

			#Else - 
			} elseif { [regexp "(.*)else(.*)" $line full_line zero one] } {
				#Get the last closing Bracket - \}
				if { [regexp "\}" $zero] } {
					append line "\} else "
				} else {
					#If the closing bracket is in the last line
					set line_no [.contents index insert]
					set line_no [split $line_no "."]
					set cur_line [lindex $line_no 0]
					#Make sure that the last line in the file had a '\}' char
					set temp [lindex $lines [expr $i - 1]]
					if { [regexp "(.*)\}( *)" $temp] } {
						set line_no [expr $cur_line - 1]
						.contents insert $line_no.end " else "
						set no_write 1
					}
				}
				set line_no [expr $cur_line - 1]
				#Get the next Starting Bracket - \{ - if there is no \{ in the same line
				if { ![regexp "\{" $one] } {
					incr i
					set need_line [lindex $lines [expr $i - 1]]
					append line "[startBracket $need_line]"
					#There is some confusion here - however, it works.
					if { ![regexp "(.*)\{(.*)" $need_line full_line zero one] } {
						.contents insert $line_no.end "\{"
					}
				} else {
					.contents insert $line_no.end "\{"
				}

			#Unless - No Tcl Eqvivalent - unless\($a\) = if \{!$a \}
			} elseif { [regexp "( *)unless.?\[\(\] ?(\[^\{\]*) ?\[\)\](.*)" $line full_line zero one two] } {
				set line "$zero\if \{ !$one \} $two"
				if { ![regexp "\{" $two] } {
					incr i
					set need_line [lindex $lines $i]
					append line "[startBracket $need_line]"
				}

			#For - 
			} elseif {[regexp {( *)for ?\((.*); ?(.*) ?; ?(.*) ?\)(.*)} $line full_line zero one two three four]} {
				set line "$zero for \{ $one \} \{ $two \} \{ $three \} $four"
				if { ![regexp "\{" $four] } {
					incr i
					set need_line [lindex $lines $i]
					append line "[startBracket $need_line]"
				}

			#Foreach -
			} elseif {[regexp {( *)foreach \$(.*) \(\@(.*)\)(.*)} $line full_line zero one two three four]} {
				set line "$zero foreach $one \$$two "
				if { ![regexp "\{" $three] } {
					incr i
					set need_line [lindex $lines $i]
					append line "[startBracket $need_line]"
				}

			#While - 
			} elseif {[regexp "( *)while.?\[\(\](.*)\[\)\](.*)" $line full_line zero one two]} {
				set line "$zero while \{ $one \} $two"
				if { ![regexp "\{" $two] } {
					incr i
					set need_line [lindex $lines $i]
					append line "[startBracket $need_line]"
				}
			}

#Common Phrases
 	#My Style - These phrases are used in my Perl programming
 			#$list = `dir /b *.htm`;
 			if { [regexp {(.*)\$(\w+) ?\= ?`dir \/b ?(.*)`;(.*)} $line full_line zero one two three four] } {
	 			set line "$zero\set $one \[glob -nocomplain $two\]$three"
 			}
	#Regular Expressions
			#Regular Expression - if \{$var =~ s//\}
			if { [regexp {( *)if ?\{ ?\$(.*) ?=~ ?\/(.*[^\\])\/([^\}]*) ?\}(.*)} $line full_line zero one two three four] } {
				set regopt [getRegOpt $three]
				set line "$zero\if \{ \[regexp $regopt\{$two\} \$$one full_match re1 re2 re3 re4 re5 re6\] \}$four"
			}
			#Regular Expression Substitutions - $var =~ s///;
			if { [regexp {( *)\$(.*) ?=~ ?s\/(.*[^\\])\/(.*[^\\])\/(.*);(.*)} $line full_line zero one two three four five] } {
				set regopt [getRegOpt $four]
				set line "$zero regsub $regopt\{$two\} \$$one \{$three\} $one $five"
			}
			#Regular Expressions - //
			if { [regexp {( *)if ?\{ ?\/(.*[^\\])\/(.*) ?\} ?(.*)} $line full_line zero one two three four] } {
				set regopt [getRegOpt $two]
				set line "$zero\if \{ \[regexp $regopt\{$one\} \$default full_match re1 re2 re3 re4 re5 re6\] \} $three"
			}
			#SubMatches for Regular Expressions - $1 $2, etc.
 			if { [regexp {(.*)\$(\d)(.*)} $line full_line zero one two] } {
	 			set line "$zero\$re$one$two"
 			}
	#Common
			# my VarName;
			if { [regexp {(.*)my [\$\@]([^;=]*) ?(;|=)(.*)} $line full_line zero one two three] } {
				if { $two == "=" } {
	 				set line "$zero \$$one=$three"
 				} else {
	 				set line "$zero $three"
 				}
 			}
			# <FUNCTION> || <SCRIPT>;
 			if { [regexp {(.*) ?\|\| ?(.*)} $line full_line zero one] } {
 				#set line "if \{ !\[$zero\] \} { $one }"
 				set line "$zero"
 			}
 			#`<SYSTEM COMMAND>`;
 			if { [regexp {(.*)`(.+)`;(.*)} $line full_line zero one two] } {
	 			set line "$zero\exec $one $two"
			}

	#File Opening and Associated Code
 			# @LINES=<FILE>;
 			if { [regexp {( *)(\@|\$)(.*) ?= ?<(.*)>;} $line full_line zero one two three] } {
	 			if { $three == "STDIN" } {
		 			set line "set $two \[gets stdin\]"
	 			} else {
	 				set line "set $two \[read \$$three\]"
 				}
 				if { $one == "@" } {
	 				append line "; set $two \[split \$$two \"\\n\"\]"
 				}
 			}
 			# $SIZE=@LINES;
 			if { [regexp {( *)\$(.*) ?= ?\@(.*);} $line full_line zero one two] } {
	 			set line "set $one \[llength \$$two\]"
 			}
	#File Arguments
 			# if(@ARGV) - Will be changed to - if \{ @ARGV \} \{
	 		if { [regexp {( *)if \{ @ARGV \} \{(.*)} $line full_line zero one] } {
	 			set line "$zero\if \{ \$argc \} \{ $one"
 			}
 			# $ARGV[x]
 			if { [regexp {(.*)\$ARGV\[([0-9]+)\](.*)} $line full_line zero one two] } {
	 			set line "$zero\[lindex \$argv $one\]$two"
 			}
 	#Arrays
 			# $#WHATEVER
 			if { [regexp {(.*)$\#(\w+)(.*)} $line full_line zero one two] } {
	 			set line "$zero\[llength \$\$one\\]$two"
 			}
 			# $ARRAY[x]
 			if { [regexp {(.*)\$(\w+)\[(.+)\](.*)} $line full_line zero one two three] } {
	 			set line "$zero\[lindex \$$one $two\]$three"
 			}

#Commands
			#Print - Can't be put in Tcl/Tk - In tcl, it is puts
			if { [regexp {(.*\W)?print (\w*) ?(.+);(.*)} $line full_line zero one two three] } {
				if { $one == "" } {
	 				set line "$zero $print $two $three"
 				} else {
	 				set line "$zero puts \$$one $two $three"
 				}
 			} elseif { [regexp {(.*\W)?print ?;(.*)} $line full_line zero one two] } {
	 			set line "$zero $print \"\$default\" $two"
 			}
 			#die - Can't be put in Tcl/Tk
			if { [regexp "(.*)die (\"|\')(.*)(\"|\');(.*)" $line full_line zero one two three four] } {
 				set line "$zero $print \"$two\"; exit $four"
 			}
			#Open
 			if { [regexp {(.*)open ?\((.+),(.+)\);?(.*)} $line full_line zero one two three] } {
	 			if { [regexp {\"?>>([^\"]+)\"?} $two full_line two] } {
		 			set addition "a"
	 			} elseif { [regexp {\"?>([^\"]+)\"?} $two full_line two] } {
		 			set addition "w"
	 			} else {
		 			#To remove the " chars
		 			regexp {\"?([^\"]+)\"?} $two full_line two
		 			set addition "r"
	 			}
	 			set line "$zero\set $one \[open \"$two\" $addition\]$three"
 			}
 			#Close
 			if { [regexp {(.*)close ?\(?([^\)]*)\)?;(.*)} $line full_line zero one two] } {
 				set line "$zero\close \$$one"
 			}
 			#Exit
 			if { [regexp {(.*)exit ?\(?([^\)]*)\)?;(.*)} $line full_line zero one two] } {
 				set line "$zero\exit $one"
 			}
 			#split - split(/\s+/, $list);
 			if { [regexp {(.*)split ?\((\"|\/)([^,\"\/\)]*)(\"|\/),? ?([^\)]*)\);(.*)} $line full_line zero one two three four five] } {
	 			if { $four == "" } {
		 			set four "\$default"
	 			}
 				set line "$zero\[split $four \"$two\"\]$five"
 			}
 			# chdir
 			if { [regexp {(.*)chdir ?\(?\"?([^\"\);]+)\"?\)?;?(.*)} $line full_line zero one two] } {
 				set line "$zero\cd \"$one\" $two"
 			}
 			# chop
 			if { [regexp {(.*)chop ?\(?\"?\$?([^\"\);]*)\"?\)?;?(.*)} $line full_line zero one two] } {
	 			if { $one == "" } { 
		 			set one "default"
	 			}
 				set line "$zero\set $one \[string trimleft \$$one\]$two"
 			}
 			# length
 			if { [regexp {(.*\W) ?length ?\(?\"?\$?([^\"\);]*)\"?\)?;?(.*)} $line full_line zero one two] } {
	 			if { $one == "" } { 
		 			set one "default"
	 			}
 				set line "$zero\[string length \$$one\]$two"
 			}
 			# mkdir
 			if { [regexp {(.*)mkdir ?\(?\"?([^\"\);]+)\"?\)?;?(.*)} $line full_line zero one two] } {
 				set line "file mkdir \"$one\""
 			}
 			# rename
 			if { [regexp {(.*)rename ?\(\"?([^\"\),;]+) ?, ?\"?([^\"\);]+)\"?\);?(.*)} $line full_line zero one two three] } {
 				set line "$zero file rename -force \"$one\" \"$two\" $three"
 			}
 			# substr EXPR,OFFSET,LEN ?,NEW VALUE?
 			if { [regexp {(.*)substr ?\(\"?([^\"\),;]+) ?, ?\"?([^\"\),;]+)\"? ?,? ?\"?([^\"\),;]*)\"? ?,? ?([^\);]*)\);(.*)} $line full_line zero one two three four five] } {
	 			if { $four == "" } {
	 				set line "$zero\[string range $one $two $three\]$four"
 				} else {
	 				set line "$zero\[string replace $one $two $three $four\]$five"
 				}
 			}
 			# rindex STR,SUBSTR,POSITION
 			if { [regexp {(.*)rindex ?\(\"?([^\"\),;]+) ?, ?\"?([^\"\),;]+)\"? ?,? ?\"?([^\"\),;]*)\"? ?\);(.*)} $line full_line zero one two three four] } {
				set line "$zero\[string last $one $two $three\]$four"
 			}
 			# index
 			if { [regexp {(.*)index ?\(\"?([^\"\),;]+) ?, ?\"?([^\"\),;]+)\"? ?,? ?\"?([^\"\),;]*)\"? ?\);(.*)} $line full_line zero one two three four] } {
				set line "$zero\[string first $one $two $three\]$four"
 			}
 			# sort
 			if { [regexp {(.*)\= ?sort ?\(? ?(\$|\@)(\w+) ?\)?;?(.*)} $line full_line zero one two three] } {
				set line "$zero= \[lsort $two\]$three"
 			} elseif { [regexp {(.*)sort ?\(? ?(\$|\@)(\w+) ?\)?;?(.*)} $line full_line zero one two three] } {
				set line "$zero\set $two \[lsort $two\]$three"
 			}

#Expressions
			if { [regexp "\[\-\+=\/\]" $line] } {
				#++ 
				if { [regexp {(.*)[$](.*)\+\+;?(.*)} $line full_line zero one two]} {
					set line "$zero\incr $one $two"
				}
				#--
				if { [regexp {(.*)[$](\w+)--;?(.*)} $line full_line zero one two]} {
					set line "$zero\set \[expr \$$one - 1] $two"
				}

				# == <= >= < > - Same
				#eq
				if { [regexp "(.+) eq (.+)" $line full_line zero one two]} {
					set line "$zero == $one"
				}

				# $variable \[.+-/*\]= $another_variable
				if { [regexp {(.*)\$(\w+) ?([-\+\.\*\/])\= ?(.+);(.*)} $line full_line zero one two three four]} {
					set line "$zero\$$one = \$$one $two $three;"
				}

				# .
				if { [regexp {(.*)\$(\w+) ?\= ?(.+) ?\. ?(.+)?;} $line full_line zero one two three]} {
					set line "$zero\set $one \[concat $two $three\]"
				}

				# + - * / %
				if { [regexp "(.*)\=\[ \]?(.+)\[ \]?(\[-\+\*\%\/\])\[ \]?(.+);" $line full_line zero one two three four]} {
					#Make sure that it is a arethmatic operation. There right and left 
					#	elements should be a variable, a digit or a return of a function
 					if { ([regexp {[\$\@].*} $one]) || ([regexp {\d+} $one]) || ([regexp {\[.*\]} $one]) } {
 						if { ([regexp {[\$\@].*} $three]) || ([regexp {\d+} $three]) || ([regexp {\[.*\]} $three]) } {
							set line "$zero= \[expr $one $two $three\];"
 						}
 					}
				}

				# =
	 			if { [regexp {(.*)[\$\@](\w+) ?= ?([^;]+);?(.*)} $line full_line zero one two three]} {
		 			#If the perl script has the '$_' value
		 			if { $one == "_" } { set one "default" }
		 			if { $two == "\$_" } { set two "\$default" }
	 				set line "$zero\set $one $two $three"
	 			}
	 			#To replace within the for loop - for \{ $i = 0 \} \{...
	 			if { [regexp {(.*)for \{[ ]+[$]([^\{]+) ?[=] ?([^\{]+)[ ]+\} (.*)} $line full_line zero one two three four] } {
		 			set line "$zero for \{ set $one $two \} $three"
	 			}
			} 

			#Write whatever there is to write
			if { !$no_write } {
				set line_no [.contents index insert]
				set line_no [split $line_no "."]
				set cur_line [lindex $line_no 0]
# 				#No changes
# 				if { [lindex $lines $i] == $line } {
# 					.contents insert end "[expr $i + 1]:$cur_line\] $line\n"
# 				} else {
					.contents insert end "$line\n"
#				}
			}
		}
	}
	return $flag
}
#Return the options in a regular expression - //OPTS
proc getRegOpt { opts } {
	set regopt ""
	if { [string first "g" $opts] != -1 } {
		append regopt "-all "
	}
	if { [string first "i" $opts] != -1 } {
		append regopt "-nocase "
	}
	if { [string first "m" $opts] != -1 } {
		append regopt "-line -linestop -lineanchor "
	}
	return $regopt
}
#Get the beginning \{ and put it in the same line - for IF loops, FOR loops etc.
proc startBracket { in_line } {
	set line ""
	#Get the beginning \{ and put it in the same line
	if { [regexp "(.*)\{(.*)" $in_line full_line zero one] } {
		append line " \{"
		if { $one != "" } {
			append line "\n$one"
		}
	}
	#tk_messageBox -message "Changed\n$in_line\nto\n$line"
	return $line
}

##########################
# Regular Expression Help
##########################
# \w - All Aphanumarical charectors and underscore - \[a-zA-Z0-9_\] - Used for variable names
# \d - Digit - \[0-9\]
#
##########################
# TO DO
##########################
# A lot more commands
# Comments
# #!usr/bin/perl must be changed
# print << SOMEWHERE
# ++$variable
#
##########################
# Bugs
##########################
# Problem with \} else \{ - The first bracket '\}' is not appearing
#
	  